import 'dart:convert';

import 'package:flutter/material.dart';
// import 'package:midtrans_helper/midtrans_helper.dart';
import 'package:midtrans_helper/qr_code.dart';

import 'package:request_api_helper/request_api_helper.dart';

class MidtransPay{
  String id,
         url;
  Function getStatus;
  ///```
  ///[{
  ///   "id": "a01",
  ///   "price": 6000,
  ///   "quantity": 1,
  ///   "name": "Apple"
  /// }],
  ///```
  List itemDetail;
  /// ```
  /// {
  /// "first_name": "Budi",
  /// "last_name": "Susanto",
  /// "email": "budisusanto@example.com",
  /// "phone": "+628123456789",
  /// "billing_address": {
  ///   "first_name": "Budi",
  ///   "last_name": "Susanto",
  ///   "email": "budisusanto@example.com",
  ///   "phone": "08123456789",
  ///  "address": "Sudirman No.12",
  ///  "city": "Jakarta",
  ///  "postal_code": "12190",
  ///  "country_code": "IDN"
  /// }
  /// ```
  Map<String,dynamic> customerDetail;
  /// ```
  /// {
  ///   "first_name": "Budi",
  ///   "last_name": "Susanto",
  ///   "email": "budisusanto@example.com",
  ///   "phone": "0812345678910",
  ///   "address": "Sudirman",
  ///   "city": "Jakarta",
  ///   "postal_code": "12190",
  ///   "country_code": "IDN"
  /// }
  /// ```
  Map<String,dynamic> alamatPengiriman;
  /// ```
  /// {
  ///   "order_id": "CustOrder-110",
  ///   "gross_amount": 9000,
  /// },
  /// ```
  Map<String,dynamic> detailTransaksi;
  /// midtrans server key
  String serverKey;

  MidtransPay({
    this.id,
    this.url,
    this.getStatus,
    this.itemDetail,
    this.customerDetail,
    this.alamatPengiriman,
    @required this.detailTransaksi,
    @required this.serverKey,
  });

  send(context) async {
    String encoded = utf8.fuse(base64).encode(serverKey);
    if(customerDetail is Map){ 
      if(alamatPengiriman is Map){
        customerDetail.addAll({"shipping_address" : alamatPengiriman});
      }
    }

    dynamic data = {
      "transaction_details": detailTransaksi,
      "item_details": itemDetail,
      "customer_details": customerDetail,
    };

    if(id == 'gopay'){
      data.addAll({"payment_type": "gopay"});
    }else if(id == 'bca'){
      data.addAll({"payment_type": "bca"});
    }

    dynamic body = json.encode(data);
    Map<String,String> header = {
      'Accept' : 'application/json',
      'Authorization' : 'Basic $encoded',
      'Content-Type':'application/json',
    };

    await Post(
      customHeader: header,
      customUrl: '${url}charge',
      body: utf8.encode(body),
      onSuccess: (data) async {
          print(data);
        if(data['status_code'].toString() == '201'){
          await Navigator.push(context,
            MaterialPageRoute(builder:(context)=> QRCode(
              url: data['actions'][0]['url'],
            )),
          );
          getStatus(data,true);
        }else if(data['status_code'].toString() == '406'){
          getStatus(data,false);
        }
      },
    ).request(context);
  }
}